#include < amxmodx >
#include < amxmisc >
#include < fun >

#define I_LVL ADMIN_RCON

#define PLUGIN "Give Weapon"
#define VERSION "1.0"
#define AUTHOR "OverGame"

new const cPrefix[] = "!g[!tГлоб. Оружейка!t]!y"

#pragma tabsize 0

new gMaxPlayers, gWName[255]

public plugin_init()
{
    register_plugin( PLUGIN, VERSION, AUTHOR )
	
	register_clcmd( "say /gweapon", "select_weapon" )
	register_clcmd( "say_team /gweapon", "select_weapon" )
	register_clcmd( "gweapon", "select_weapon" )
	
	gMaxPlayers = get_maxplayers()
}

public select_weapon(id)
{
    if ( !(get_user_flags(id) & I_LVL) )
	{
	    ChatColor( id, "%s У вас недостаточно прав.", cPrefix )
	    return PLUGIN_HANDLED
	}
		
	static s_MenuItem[255]
	formatex(s_MenuItem, charsmax(s_MenuItem), "\rГлобальная оружейка")
	new menu = menu_create(s_MenuItem, "select_weapon_hand" )

	menu_additem(menu, "\yДать всем\r AWP", "1")
	menu_additem(menu, "\yДать всем\r M4A1", "2")
	menu_additem(menu, "\yДать всем\r AK47", "3")
	menu_additem(menu, "\yДать всем\r FAMAS", "4")
	menu_additem(menu, "\yДать всем\r DEAGLE", "5")

	menu_setprop(menu, MPROP_BACKNAME, "Назад")
	menu_setprop(menu, MPROP_NEXTNAME, "Далее")
	menu_setprop(menu, MPROP_EXITNAME, "Выход")

	menu_display(id,menu,0)
	return PLUGIN_HANDLED
}

public select_weapon_hand(id, menu, item) 
{
	if(item == MENU_EXIT) 
	{
	menu_destroy(menu)
	return PLUGIN_HANDLED
	}

	new data[6], iName[64], access, callback, gMsg[255], gName[32]
	menu_item_getinfo(menu, item, access, data, 5, iName, 63, callback)

	new key = str_to_num(data)
	
	get_user_name(id, gName, 31)
	
	switch(key) 
	{
		case 1:
		{
			formatex( gWName, charsmax(gWName), "weapon_awp" )
			formatex( gMsg, charsmax(gMsg), "%s Админ!g %s!y дал всем!t AWP", cPrefix, gName )
		}
		case 2:
		{
			formatex( gWName, charsmax(gWName), "weapon_m4a1" )
			formatex( gMsg, charsmax(gMsg), "%s Админ!g %s!y дал всем!t M4A1", cPrefix, gName )
		}
		case 3:
		{
			formatex( gWName, charsmax(gWName), "weapon_ak47" )
			formatex( gMsg, charsmax(gMsg), "%s Админ!g %s!y дал всем!t AK47", cPrefix, gName )
		}
		case 4:
		{
			formatex( gWName, charsmax(gWName), "weapon_famas" )
			formatex( gMsg, charsmax(gMsg), "%s Админ!g %s!y дал всем!t FAMAS", cPrefix, gName )
			
		}
		case 5:
		{
			formatex( gWName, charsmax(gWName), "weapon_deagle" )
			formatex( gMsg, charsmax(gMsg), "%s Админ!g %s!y дал всем!t Deagle", cPrefix, gName )
		}
	}
	
	ChatColor(0, gMsg)
	give_weapon()
	
	select_weapon(id)
	
	return PLUGIN_HANDLED
}

public give_weapon()
{
   for(new id = 0; id <= gMaxPlayers; id++)
   {
        if(!is_user_bot(id) && is_user_connected(id) && is_user_alive(id))
        {
			give_item(id, gWName)
			give_item(id, gWName)
			give_item(id, gWName)
			give_item(id, gWName)
			give_item(id, gWName)
			give_item(id, gWName)
		}
	}
}

stock ChatColor(const id, const input[], any:...)
{
	new count = 1, players[32]
	static msg[188]
	vformat(msg, 187, input, 3)
	
	replace_all(msg, 187, "!g", "^4")
	replace_all(msg, 187, "!y", "^1")
	replace_all(msg, 187, "!t", "^3")
	
	if (id) players[0] = id; else get_players(players, count, "ch")
	{
		for (new i = 0; i < count; i++)
		{
			if (is_user_connected(players[i]))
			{
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i]);
				write_byte(players[i]);
				write_string(msg);
				message_end();
			}
		}
	}
}